rm(list=ls(all=TRUE))
library(MCMCpack)
library(mvtnorm)
library(tensor)
library(mnormt)
library(rmgarch)
library(gdata)
library(pscl)
M=read.table("data-currency.txt",header=TRUE)
m=log(M)
M=as.matrix(m[1:700,1:5])
obs=diff(M)
plot.ts(obs)
N<-100#number of particles
Ti=699#number of Time
dim=5#dimention
k=5
mu=matrix(rep(0,dim),nrow=1,ncol=dim)
C=10000
D=0.0001

#obs=array(D,dim=c(1,dim,Ti))
###########SMC
ESS<-rep(N/2,Ti)
NESS<-N/2
xs<-array(rep(diag(dim),N*(Ti+1)),dim=c(dim,dim,N,Ti+1))
Weight=array(rep(1/N,N*(Ti+1)),dim=c(N,Ti+1))
A=array(rep(diag(dim),(Ti)),dim=c(dim,dim,Ti+1))
beta=diag(dim)
xt=array(rep(0,(Ti+1)*dim),dim=c(Ti+1,dim))
Dt=array(rep(0,(Ti+1)*dim),dim=c(Ti+1,dim))
at=array(rep(0,(Ti+1)*dim),dim=c(Ti+1,dim))
####sr-function
squareroot=function(x)
{
e=eigen(x)
V=e$vectors
B=V %*% diag(sqrt(e$values)) %*% t(V)
B
}
inverse=function(y)
{
e=eigen(y)
V=e$vectors
B=V %*% diag(1/(e$values)) %*% t(V)
B
}
######for t=0##############
####prior for A and x
for (i in 1:N)
{
xs[,,i,1]=riwish(k,(k-dim-1)*diag(dim))              
}
for (i in 1:dim)
{
xt[1,i]=weighted.mean(xs[i,i,,1],Weight[,1])
}


######for t=1##############
for (i in 1:dim)
{
Dt[1,i]=D
}

for (i in 1:dim)
{
at[1,i]=rgamma(1,C,scale=Dt[1,i])
}

A[,,1]=diag(c(at[1,]))
for (i in 1:N)
{
xs[,,i,2]=riwish(k,(k-dim-1)*(A[,,1])%*% xs[,,i,1] %*% t(A[,,1]))           
}
for (i in 1:dim)
{
xt[2,i]=weighted.mean(xs[i,i,,2],Weight[,2])
}

######for t=2...Ti#######
for (i in 1:dim)
{
Dt[2,i]=1/(1/Dt[1,i]+(k-dim-1)*xt[1,i]/xt[2,i]/2)
}
for (i in 1:dim)
{
at[2,i]=(Dt[2,i])*(C+(k-2*dim)/2)
}

A[,,2]=diag(c(at[2,]))
t<-3
while (t<(Ti+2))
{
####generate A and phi and SMC####
for (i in 1:N)
     {        
      
       xs[,,i,t]=riwish(k,(k-dim-1)*A[,,t-1]%*% xs[,,i,t-1] %*% t(A[,,t-1]))
   part1=dmvnorm(obs[t-1,],mu,(xs[,,i,t]))
   Weight[i,t-1]=Weight[i,t-2]*part1
     }
      Weight[,t-1]=Weight[,t-1]/sum(Weight[,t-1])
      ESS[t-2]=1/sum(Weight[,t-1]^2)
    if (ESS[t-2]<NESS)
	   {
               index=sample(N,N,replace=TRUE,prob=Weight[,t-1])
                xs[,,,t]=xs[,,index,t]
               Weight[,t-1]=rep(1/N,N)
          }
for (i in 1:dim)
{
xt[t,i]=weighted.mean(xs[i,i,,t],Weight[,t]) 
}

for (i in 1:dim)
{
Dt[t,i]=1/(1/Dt[t-1,i]+(k-dim-1)*xt[t-1,i]/xt[t,i]/2)
}

for (i in 1:dim) 
{
at[t,i]=(Dt[t,i])*(C+t*(k-2*dim)/2)
}
 
A[,,t]=diag(c(at[t,]))
t=t+1
}

